Index: branch/CELIK/sp4a12/main.c
===================================================================
--- branch/CELIK/sp4a12/main.c	(revision 279)
+++ branch/CELIK/sp4a12/main.c	(revision 280)
@@ -38,7 +38,6 @@
             test=0;
         }
     }
-
     return test;
 }
 
@@ -46,7 +45,7 @@
 {
     int res;
 
-    if ((c>='0') && (c<='9'))
+    if ((c>=48) && (c<=58))
     {
         res = c-48;
     }
@@ -62,12 +61,56 @@
     int temp = 0; // initialisation du resultat 0
     int i;
 
-    for (i=0; i<n ; i++)
+    for (i=0; i<n; i++)
     {
         temp = (temp*10) + decode_int(ch[i]); // permet de reconstituer le nombre terme a terme par puissance de 10
     }
     return temp;
 }
+
+float decode_latitude (char *trame) /* Fonction convertissant la chaîne de caractère contenant la latitude en nombre flottant et son test unitaire */
+{
+    int i;
+    char minute[5];
+    float degreLat, minLat, resDecodeLat;
+
+    for (i=0; i<4; i++)
+        {
+            minute[i] = trame[i+22];
+        }
+    degreLat = 10*decode_int(trame[17]) + decode_int(trame[18]);
+    minLat = 10*decode_int(trame[19]) + decode_int(trame[20]) + 0.0001*decode_nombre(minute,4);
+    resDecodeLat = degreLat + minLat/60;
+
+    return resDecodeLat;
+}
+
+float decode_longitude (char *trame) /* Fonction convertissant la chaîne de caractère contenant la longitude en nombre flottant et son test unitaire */
+{
+    int i;
+    char minute[5];
+    float degreLong, minLong, resDecodeLong;
+
+    for (i=0 ; i<4 ; i++)
+    {
+        minute[i] = trame[i+35];
+    }
+
+    degreLong = 100*decode_int(trame[29]) + 10*decode_int(trame[30]) + decode_int(trame[31]);
+    minLong = 10*decode_int(trame[32]) + decode_int(trame[33]) + 0.0001*decode_nombre(minute,4);
+    resDecodeLong = degreLong + minLong/60;
+
+    return resDecodeLong;
+}
+
+float decode_position() /* Fonction qui décode indifféremment une latitude ou une longitude */
+{
+    int i;
+    char minute[5];
+    float degrePos, minPos, resDecodePos;
+
+    return resDecodePos;
+}
 
 //Ajouter vos tests unitaires dans cette fonction.
 void tests_unitaires(void)
@@ -90,17 +133,21 @@
             exit(-1);
         }
 
-    if (trame_cmp("$GPGSV suite chaine","GPGGA") != 0)
+    if (trame_cmp("$GPRMC suite chaine","GPRMC") != 1)
         {
             printf ("Erreur Test unitaire trame_cmp.\n");
             exit(-1);
         }
 
-    if (trame_cmp("$GPGLL suite chaine","GPGGA") != 0)
+    if (trame_cmp("$APRMC suite chaine","GPGGA") != 0)
         {
             printf ("Erreur Test unitaire trame_cmp.\n");
             exit(-1);
-        }
+        }
+    test_decode_int();
+    test_decode_nombre();
+    test_decode_latitude();
+    test_decode_longitude();
 }
 
 void test_decode_int(void)
@@ -107,60 +154,115 @@
 {
     if (decode_int('0') != 0)
     {
-        printf ("erreur test unitaire decode_int\n");
+        printf ("erreur test unitaire decode_int_10\n");
+        exit(-1);
     }
 
     if (decode_int('1') != 1)
     {
-        printf ("erreur test unitaire decode_int\n");
+        printf ("erreur test unitaire decode_int_11\n");
+        exit(-1);
     }
 
     if (decode_int('2') != 2)
     {
-        printf ("erreur test unitaire decode_int\n");
+        printf ("erreur test unitaire decode_int_12\n");
+        exit(-1);
     }
 
     if (decode_int('3') != 3)
     {
-        printf ("erreur test unitaire decode_int\n");
+        printf ("erreur test unitaire decode_int_13\n");
+        exit(-1);
     }
 
     if (decode_int('4') != 4)
     {
-        printf ("erreur test unitaire decode_int\n");
+        printf ("erreur test unitaire decode_int_14\n");
+        exit(-1);
     }
 
     if (decode_int('5') != 5)
     {
-        printf ("erreur test unitaire decode_int\n");
+        printf ("erreur test unitaire decode_int_15\n");
+        exit(-1);
     }
 
     if (decode_int('6') != 6)
     {
-        printf ("erreur test unitaire decode_int\n");
+        printf ("erreur test unitaire decode_int_16\n");
+        exit(-1);
     }
 
     if (decode_int('7') != 7)
     {
-        printf ("erreur test unitaire decode_int\n");
+        printf ("erreur test unitaire decode_int_17\n");
+        exit(-1);
     }
 
     if (decode_int('8') != 8)
     {
-        printf ("erreur test unitaire decode_int\n");
+        printf ("erreur test unitaire decode_int_18\n");
+        exit(-1);
     }
 
     if (decode_int('9') != 9)
     {
-        printf ("erreur test unitaire decode_int\n");
+        printf ("erreur test unitaire decode_int_19\n");
+        exit(-1);
     }
 
     if (decode_int('A') != -1)
     {
-        printf ("erreur test unitaire decode_int\n");
+        printf ("erreur test unitaire decode_int_2\n");
+        exit(-1);
     }
 
+    if (decode_int('Z') != -1)
+    {
+        printf ("erreur test unitaire decode_int_3\n");
+        exit(-1);
+    }
 }
+
+void test_decode_nombre()
+{
+    char t[5];
+    t[0] = '1';
+    t[1] = '2';
+    t[2] = '3';
+    t[3] = '4';
+
+    if (decode_nombre(t,1) != 1)
+    {
+        printf ("Erreur test unitaire decode_nombre_1\n");
+        exit(-1);
+    }
+
+    if (decode_nombre(t,4) != 1234)
+    {
+        printf ("Erreur test unitaire decode_nombre_2\n");
+        exit(-1);
+    }
+}
+
+void test_decode_latitude()
+{
+    if (decode_latitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D") != 45.75)
+    {
+        printf ("Erreur test unitaire decode_latitude\n");
+        exit(-1);
+    }
+}
+
+void test_decode_longitude()
+{
+    if (decode_longitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D") != 3.1100599765777588)
+    {
+        printf ("Erreur test unitaire decode_longitude\n");
+        exit(-1);
+    }
+}
 
 // Ne pas modifier cette fonction
 int main(int argc,char ** argv)