Index: branch/DESFRICHES-DORIA/sp4a12/main.c
===================================================================
--- branch/DESFRICHES-DORIA/sp4a12/main.c	(revision 300)
+++ branch/DESFRICHES-DORIA/sp4a12/main.c	(revision 301)
@@ -2,6 +2,10 @@
 #include <stdlib.h>
 #include <strings.h>
 #include "trame.h"
+typedef struct{
+    float latitude;
+    float longitude;
+} Position;
 
 //Trames de tests à modifier si nécessaire.
 char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
@@ -12,62 +16,113 @@
                     "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
                     "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
                     "$GPZDA,141914.00,01,02,2006,00,00*69",
-                    0};
+                    0};
+
+int trame_cmp(char *trame, char *type){
+    int test=1;
+    int i;
 
-int exposant(int n)
-{
+    for(i=0;i<5;i++){
+        if(trame[i+1]!=type[i]){
+            test=0;
+        }
+    }
+
+    return test;
+}
+
+//Fonction à modifier !!!!!
+void traitement(char * trame){
+    static int cpt=0;
+    cpt++;
+
+    if (trame_cmp(trame,"GPGGA")==1){
+        printf ("> %s\n",trame);
+    }
+}
+
+
+
+int decode_int(char c){
+    int res;
+
+    if((c>=48)&&(c<=58)){
+        res=c-48;
+    }
+    else{
+       res=-1;
+    }
+    return res;
+}
+
+int decode_nombre(char *ch,int n){
+    int r=0;
     int i;
-    int expo = 1;
-    for(i=0; i<n; i++)
-        expo = expo*10;
-    return(expo);
+
+    for(i=0;i<n;i++){
+        r=10*r+decode_int(ch[i]);
+    }
+    return r;
 }
 
-int decode_int(char c)
-{
-    int valeur;
-    if((c>47)&&(c<=58))
-        valeur = c-48;
-    else
-        valeur = -1;
-    return(valeur);
+float decode_latitude(char *trame){
+    int i;
+    char minute[5];
+    float degreLat;
+    float minLat;
+    float resDecodeLat;
+
+    for(i=0;i<4;i++){
+        minute[i]=trame[i+22];
+    }
+
+    degreLat=10*decode_int(trame[17])+decode_int(trame[18]);
+    minLat=10*decode_int(trame[19])+decode_int(trame[20])+0.0001*decode_nombre(minute,4);
+
+    resDecodeLat=degreLat+minLat/60;
+
+    return resDecodeLat;
 }
-int trame_cmp(char * trame, char * type)
-{
-    int i = 0;
-    int ok;
-    do
-    {
-        if(trame[i]==type[i])
-            i++;
+
+float decode_longitude(char *trame){
+    int i;
+    char minute[5];
+    float degreLong;
+    float minLong;
+    float resDecodeLong;
+
+    for(i=0;i<4;i++){
+        minute[i]=trame[i+35];
     }
-    while((trame[i]==type[i])&&(type[i]!='\0'));
-    if(type[i]=='\0')
-        ok = 1;
-    else
-        ok = 0;
-    return(ok);
+
+    degreLong=100*decode_int(trame[29])+10*decode_int(trame[30])+decode_int(trame[31]);
+    minLong=10*decode_int(trame[32])+decode_int(trame[33])+0.0001*decode_nombre(minute,4);
+
+    resDecodeLong=degreLong+minLong/60;
+
+    return resDecodeLong;
 }
 
-int decode_nombre(char * ch, int n)
+Position decode_position(char *trame)
 {
-    int r;
-    int i;
-    for(i=0; i<n; i++)
+    Position p;
+
+    p.latitude = decode_latitude(trame);
+    p.longitude = decode_longitude(trame);
+
+    return p;
+}
+
+Position decode_trame(char *trame)
+{
+    Position pos;
+
+    if (trame_cmp(trame,"GPGGA")==1)
     {
-        r = r*10 + decode_int(ch[i]);
+        pos = decode_position(trame);
     }
-    return (r);
-}
-//Fonction à modifier !!!!!
-void traitement(char * trame)
-{
-    static int cpt = 0;
-    cpt++;
-
-    if(trame_cmp(trame, "$GPGGA")==1);
-    printf ("> %s\n",trame);
-}
+    return pos;
+}
 
 //Ajouter vos tests unitaires dans cette fonction.
 void tests_unitaires(void){
@@ -74,68 +129,162 @@
     if (5!=5){
         printf ("Erreur Test unitaire basique.\n");
         exit(-1);
-    }
-    if (trame_cmp("$GPGGA suite chaine","GPGGA")!=1){
-        printf ("Erreur Test unitaire trame_cmp.\n");
-        exit(-1);
     }
-        if (trame_cmp("$GPRMC suite chaine","GPGGA")!=0){
-        printf ("Erreur Test unitaire trame_cmp.\n");
-        exit(-1);
+
+    if(trame_cmp("$GPGGA suite chaine","GPGGA")!=1){
+        printf("Erreur test unitaire trame_cmp\n");
+        exit(-1);
     }
-        if (trame_cmp("$GPRMC...","GPGGA")!=1){
-        printf ("Erreur Test unitaire trame_cmp.\n");
-        exit(-1);
-    }    if (trame_cmp("$GPGGA suite chaine","GPGGA")!=1){
-        printf ("Erreur Test unitaire trame_cmp.\n");
+    if(trame_cmp("$GPRMC suite chaine","GPGGA")!=0){
+        printf("Erreur test unitaire trame_cmp\n");
         exit(-1);
     }
-        if (trame_cmp("$APRMC...","GPGGA")!=0){
-        printf ("Erreur Test unitaire trame_cmp.\n");
-        exit(-1);
-    }
-}
+    if(trame_cmp("$GPRMC suite chaine","GPRMC")!=1){
+        printf("Erreur test unitaire trame_cmp\n");
+        exit(-1);
+    }
+    if(trame_cmp("$APRMC suite chaine","GPGGA")!=0){
+        printf("Erreur test unitaire trame_cmp\n");
+        exit(-1);
+    }
 
-void test_decode_int(void)
-{
-    if(decode_int('0')!=0)
-        printf("Erreur Test decode_int en 0.\n");
-    exit(-1);
-    if(decode_int('1')!=1)
-        printf("Erreur Test decode_int en 1.\n");
-    exit(-1);
-    if(decode_int('2')!=2)
-        printf("Erreur Test decode_int en 2.\n");
-    exit(-1);
-    if(decode_int('3')!=3)
-        printf("Erreur Test decode_int en 3.\n");
-    exit(-1);
-    if(decode_int('4')!=4)
-        printf("Erreur Test decode_int en 4.\n");
-    exit(-1);
-    if(decode_int('5')!=5)
-        printf("Erreur Test decode_int en 5.\n");
-    exit(-1);
-    if(decode_int('6')!=6)
-        printf("Erreur Test decode_int en 6.\n");
-    exit(-1);
-    if(decode_int('7')!=7)
-        printf("Erreur Test decode_int en 7.\n");
-    exit(-1);
-    if(decode_int('8')!=8)
-        printf("Erreur Test decode_int en 8.\n");
-    exit(-1);
-    if(decode_int('9')!=9)
-        printf("Erreur Test decode_int en 9.\n");
-    exit(-1);
+    test_decode_int();
+
+    test_decode_nombre();
+
+    test_decode_latitude();
+
+    test_decode_longitude();
+
+    test_decode_position();
 }
 
-// Ne pas modifier cette fonctionp[0]='7';
+void test_decode_int(void){
+    if(decode_int('0')!=0){
+        printf("Erreur test unitaire decode-int10\n");
+        exit(-1);
+    }
+    if(decode_int('1')!=1){
+        printf("Erreur test unitaire decode-int11\n");
+        exit(-1);
+    }
+    if(decode_int('2')!=2){
+        printf("Erreur test unitaire decode-int12\n");
+        exit(-1);
+    }
+    if(decode_int('3')!=3){
+        printf("Erreur test unitaire decode-int13\n");
+        exit(-1);
+    }
+    if(decode_int('4')!=4){
+        printf("Erreur test unitaire decode-int14\n");
+        exit(-1);
+    }
+    if(decode_int('5')!=5){
+        printf("Erreur test unitaire decode-int15\n");
+        exit(-1);
+    }
+    if(decode_int('6')!=6){
+        printf("Erreur test unitaire decode-int16\n");
+        exit(-1);
+    }
+    if(decode_int('7')!=7){
+        printf("Erreur test unitaire decode-int17\n");
+        exit(-1);
+    }
+    if(decode_int('8')!=8){
+        printf("Erreur test unitaire decode-int18\n");
+        exit(-1);
+    }
+    if(decode_int('9')!=9){
+        printf("Erreur test unitaire decode-int19\n");
+        exit(-1);
+    }
+
+    if(decode_int('A')!=-1){
+        printf("Erreur test unitaire decode-int2\n");
+        exit(-1);
+    }
+    if(decode_int('Z')!=-1){
+        printf("Erreur test unitaire decode-int3\n");
+        exit(-1);
+    }
+}
+
+void test_decode_nombre(void){
+    char t[5];
+    t[0]='1';t[1]='2';t[2]='3';t[3]='4';
+
+    if(decode_nombre(t,1)!=1){
+        printf("Erreur test unitaire decode-nombre1\n");
+        exit(-1);
+    }
+    if(decode_nombre(t,4)!=1234){
+        printf("Erreur test unitaire decode-nombre2\n");
+        exit(-1);
+    }
+}
+
+void test_decode_latitude(void){
+    if(decode_latitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D")!=45.75){
+        printf("Erreur test unitaire decode_latitude\n");
+        exit(-1);
+    }
+}
+
+void test_decode_longitude(void){
+    if(decode_longitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D")!=3.1100599765777588){
+        printf("Erreur test unitaire decode_longitude\n");
+        exit(-1);
+    }
+}
+
+void test_decode_position(void){
+
+    if(decode_position("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").longitude!=3.1100599765777588){
+        printf("Erreur test unitaire decode_position1\n");
+        exit(-1);
+    }
+    if(decode_position("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").latitude!=45.75){
+        printf("Erreur test unitaire decode_position2\n");
+        exit(-1);
+    }
+    if(decode_position("$GPGGA,141914.00,4545.0000,N,12412.6012,E,1,05,3.4,499.3,M,,M,,*7D").longitude!=124.21002197265625){
+        printf("Erreur test unitaire decode_position3\n");
+        exit(-1);
+    }
+    if(decode_position("$GPGGA,141914.00,2734.0060,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").latitude!=27.566766738891602){
+        printf("Erreur test unitaire decode_position4\n");
+        exit(-1);
+    }
+}
+
+void test_decode_trame(void){
+
+    if(decode_trame("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").longitude!=3.1100599765777588){
+        printf("Erreur test unitaire decode_trame1\n");
+        exit(-1);
+    }
+    if(decode_trame("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").latitude!=45.75){
+        printf("Erreur test unitaire decode_trame2\n");
+        exit(-1);
+    }
+    if(decode_trame("$GPGGA,141914.00,4545.0000,N,12412.6012,E,1,05,3.4,499.3,M,,M,,*7D").longitude!=124.21002197265625){
+        printf("Erreur test unitaire decode_trame3\n");
+        exit(-1);
+    }
+    if(decode_trame("$GPGGA,141914.00,2734.0060,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").latitude!=27.566766738891602){
+        printf("Erreur test unitaire decode_trame4\n");
+        exit(-1);
+    }
+}
+
+// Ne pas modifier cette fonction
 int main(int argc,char ** argv)
 {
 
-   //tests_unitaires();
-   test_decode_int();
+    tests_unitaires();
+
     // Affichage des trames definies dans la table trames.
     printf ("Trames de tests tableau trames:\n");
     int i=0;
@@ -142,13 +291,13 @@
     while (trames[i])
         traitement(trames[i++]);
 
-    if (!trame_init())
-        exit(-1);
-
+    if (!trame_init())
+        exit(-1);
     // Affichage des trames du fichier gps.log
     char *trame;
     printf ("Trames de tests du fichier gps.log\n");
     while  ((trame = trame_suivante()))
         traitement(trame);
+
     return 0;
 }