Index: branch/CELIK/sp4a12/main.c
===================================================================
--- branch/CELIK/sp4a12/main.c	(revision 316)
+++ branch/CELIK/sp4a12/main.c	(revision 317)
@@ -1,7 +1,16 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <strings.h>
-#include "trame.h"
+#include "trame.h"
+#include <math.h>
+
+#define pi 3.141592654
+
+/* Structures */
+typedef struct{
+    float Lat; /* latitude */
+    float Lon; /* lontitude */
+} Position;
 
 //Trames de tests à modifier si nécessaire.
 char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
@@ -20,9 +29,9 @@
     static int cpt=0;
     cpt++;
 
-    if (trame_cmp(trame,"GPGGA") == 1)
+    if (trame_cmp(trame,"GPGGA") == 1) /* test si les 2 trames sont equivalentes */
         {
-            printf ("> %s\n", trame);
+            printf ("> %s\n", trame); /* affiche uniquement les trames GPGGA */
         }
 }
 
@@ -29,11 +38,11 @@
 int trame_cmp(char *trame, char *type)
 {
     int i;
-    int test=1;
+    int test=1; /* test=1, si les 2 trames en question sont les memes */
 
     for (i=0; i<5; i++)
     {
-        if (trame[i+1] != type[i]) // verifie que le debut de la trame correspond au caractere type
+        if (trame[i+1] != type[i]) /* verifie que le debut de la trame correspond au caractere type */
         {
             test=0;
         }
@@ -41,55 +50,56 @@
     return test;
 }
 
-int decode_int(char c)
+int decode_int(char c) /* fonction qui permet de passer d'un caractere a un entier */
 {
     int res;
 
     if ((c>=48) && (c<=58))
     {
-        res = c-48;
+        res=c-48;
     }
     else
     {
-        res = -1;
+        res=-1;
     }
     return res;
 }
 
-int decode_nombre (char *ch, int n)
+int decode_nombre(char *ch, int n) /* fonction qui permet de passer d'une chaine de caractere a un entier */
 {
-    int temp = 0; // initialisation du resultat 0
+    int res=0; /* initialisation du resultat=0 */
     int i;
 
     for (i=0; i<n; i++)
     {
-        temp = (temp*10) + decode_int(ch[i]); // permet de reconstituer le nombre terme a terme par puissance de 10
+        res=10*res + decode_int(ch[i]); /* permet de reconstituer le nombre terme a terme par puissance de 10 */
     }
-    return temp;
+    return res;
 }
 
-float decode_latitude (char *trame) /* Fonction convertissant la chaîne de caractère contenant la latitude en nombre flottant et son test unitaire */
+float decode_latitude(char *trame) /* fonction convertissant la chaîne de caractère contenant la latitude en nombre flottant et son test unitaire */
 {
     int i;
-    char minute[5];
-    float degreLat, minLat, resDecodeLat;
+    char minute[5]; /*caractere de 4 */
+    float degre_Lat, min_Lat, res_decodeLat;
 
     for (i=0; i<4; i++)
         {
             minute[i] = trame[i+22];
         }
-    degreLat = 10*decode_int(trame[17]) + decode_int(trame[18]);
-    minLat = 10*decode_int(trame[19]) + decode_int(trame[20]) + 0.0001*decode_nombre(minute,4);
-    resDecodeLat = degreLat + minLat/60;
 
-    return resDecodeLat;
+    degre_Lat = 10*decode_int(trame[17]) + decode_int(trame[18]);
+    min_Lat = 10*decode_int(trame[19]) + decode_int(trame[20]) + 0.0001*decode_nombre(minute,4);
+    res_decodeLat = degre_Lat + min_Lat/60;
+
+    return res_decodeLat;
 }
 
-float decode_longitude (char *trame) /* Fonction convertissant la chaîne de caractère contenant la longitude en nombre flottant et son test unitaire */
+float decode_longitude(char *trame) /* fonction convertissant la chaîne de caractère contenant la longitude en nombre flottant et son test unitaire */
 {
     int i;
     char minute[5];
-    float degreLong, minLong, resDecodeLong;
+    float degre_Lon, min_Lon, res_decodeLon;
 
     for (i=0 ; i<4 ; i++)
     {
@@ -96,21 +106,54 @@
         minute[i] = trame[i+35];
     }
 
-    degreLong = 100*decode_int(trame[29]) + 10*decode_int(trame[30]) + decode_int(trame[31]);
-    minLong = 10*decode_int(trame[32]) + decode_int(trame[33]) + 0.0001*decode_nombre(minute,4);
-    resDecodeLong = degreLong + minLong/60;
+    degre_Lon = 100*decode_int(trame[29]) + 10*decode_int(trame[30]) + decode_int(trame[31]);
+    min_Lon = 10*decode_int(trame[32]) + decode_int(trame[33]) + 0.0001*decode_nombre(minute,4);
+    res_decodeLon = degre_Lon + min_Lon/60;
 
-    return resDecodeLong;
+    return res_decodeLon;
 }
 
-float decode_position() /* Fonction qui décode indifféremment une latitude ou une longitude */
+Position decode_position(char *trame) /* fonction qui décode indifféremment une latitude ou une longitude */
 {
-    int i;
-    char minute[5];
-    float degrePos, minPos, resDecodePos;
+    Position pos;
+    pos.Lat = decode_latitude(trame);
+    pos.Lon = decode_longitude(trame);
 
-    return resDecodePos;
+    return pos;
 }
+
+Position decode_trame(char *trame) /* fonction decode_trame() */
+{
+    Position pos;
+    pos.Lat=0;
+    pos.Lon=0;
+
+    if (trame_cmp(trame,"GPGGA") == 1)
+    {
+        pos=decode_position(trame);
+    }
+
+    return pos;
+
+}
+
+float calcule_distance (Position p1, Position p2)/* fonction qui calcule la distance (en km) entre 2 points reperes par leur latitude et longitude */
+{
+    /* variables locales */
+    const float rayon_terre = 6370.0;
+    float x, y, z;
+    float dist;
+    int k=1852;
+
+    x = (p2.Lon-p1.Lon)*cos( ((p1.Lat*pi/180)+(p2.Lat*pi/180))/2.0 );
+    y = p2.Lat-p1.Lat;
+    z = sqrt(pow(x,2)+pow(y,2));
+    dist = k*z;
+
+    return dist;
+}
+
+/* fonction qui calcule la vitesse moyenne (en km/h) entre 2 releves GPS successifs */
 
 //Ajouter vos tests unitaires dans cette fonction.
 void tests_unitaires(void)
@@ -147,7 +190,9 @@
     test_decode_int();
     test_decode_nombre();
     test_decode_latitude();
-    test_decode_longitude();
+    test_decode_longitude();
+    test_decode_position();
+    test_decode_trame();
 }
 
 void test_decode_int(void)
@@ -263,7 +308,60 @@
         exit(-1);
     }
 }
-
+
+void test_decode_position()
+{
+    if (decode_position("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").Lon != 3.1100599765777588)
+    {
+        printf ("Erreur test unitaire decode_longitude-1\n");
+        exit(-1);
+    }
+
+    if (decode_position("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").Lat != 45.75)
+    {
+        printf ("Erreur test unitaire decode_longitude-2\n");
+        exit(-1);
+    }
+
+    if (decode_position("$GPGGA,141914.00,4545.0000,N,13000.0000,E,1,05,3.4,499.3,M,,M,,*7D").Lon != 130)
+    {
+        printf ("Erreur test unitaire decode_longitude-3\n");
+        exit(-1);
+    }
+
+    if (decode_position("$GPGGA,141914.00,2734.0060,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D").Lat != 27.566766738891602)
+    {
+        printf ("Erreur test unitaire decode_longitude-4\n");
+        exit(-1);
+    }
+}
+
+void test_decode_trame()
+{
+    if (decode_trame(trames[0]).Lon != 0)
+    {
+        printf ("Erreur test unitaire decode_trame-1\n");
+        exit(-1);
+    }
+
+    if (decode_trame(trames[0]).Lat != 0)
+    {
+        printf ("Erreur test unitaire decode_trame-2\n");
+        exit(-1);
+    }
+
+    if (decode_trame(trames[4]).Lon != 3.1100599765777588)
+    {
+        printf ("Erreur test unitaire decode_trame-3\n");
+        exit(-1);
+    }
+
+    if (decode_trame(trames[4]).Lat != 45.75)
+    {
+        printf ("Erreur test unitaire decode_trame-4\n");
+        exit(-1);
+    }
+}
 // Ne pas modifier cette fonction
 int main(int argc,char ** argv)
 {