Index: branch/Fournier_Alexis/sp4a12/main.c
===================================================================
--- branch/Fournier_Alexis/sp4a12/main.c	(revision 31)
+++ branch/Fournier_Alexis/sp4a12/main.c	(revision 32)
@@ -1,51 +1,52 @@
-#include <stdio.h>
-#include <stdlib.h>
-#include <strings.h>
-#include "trame.h"
-
-//Trames de tests à modifier si nécessaire.
-char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
-                    "$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E",
-                    "$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C",
-                    "$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E",
-                    "$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",
-                    "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
-                    "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
-                    "$GPZDA,141914.00,01,02,2006,00,00*69",
-                    0};
-
-//Fonction à modifier !!!!!
-void traitement(char * trame)
+#include <stdio.h>
+#include <stdlib.h>
+#include <strings.h>
+#include "trame.h"
+
+//Trames de tests à modifier si nécessaire.
+char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
+                    "$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E",
+                    "$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C",
+                    "$GPGLL,4545.6424,N,00306.6036,E,141914.00,A*0E",
+                    "$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",
+                    "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
+                    "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
+                    "$GPZDA,141914.00,01,02,2006,00,00*69",
+                    0};
+
+//Fonction à modifier !!!!!
+void traitement(char * trame)
 {
-    static int cpt =0;
+    static int cpt=0;
     cpt++;
-
-    printf ("> %s\n",trame);
+
+    if (trame_cmp(trame,"GPGGA")==1)
+    {
+        printf ("> %s\n",trame);
+    }
 }
 
-
-
-void trame_cmp(char *trame, char *type){
-    int i =0,res=1;
-    do{
-        if (trame[i]==type[i]){
+int trame_cmp(char *trame, char *type)
+{
+    int i=0, res=1;
+    do
+    {
+        if (trame[i+1]==type[i])
+        {
             i++;
         }
-        else{
-                res=0;
-        }
-        while((type[i]!='\0')&&(res==1));
-        return (res);
-    }
+        else res=0;
+    }while ((type[i]!='\0')&&(res==1));
+    return (res);
+}
 
-}
-
-
-//Ajouter vos tests unitaires dans cette fonction.
+
+
+//Ajouter vos tests unitaires dans cette fonction.
 void tests_unitaires(void){
     if (5!=5){
-    printf ("Erreur Test unitaire basique.\n");
-    exit(-1);
+        printf ("Erreur Test unitaire basique.\n");
+        exit(-1);
     }
     if (trame_cmp("$GPGGA suite chaine","GPGGA")!=1){
         printf ("Erreur Test unitaire trame_cmp.\n");
@@ -55,43 +56,35 @@
         printf ("Erreur Test unitaire trame_cmp.\n");
         exit(-1);
     }
-    if (trame_cmp("$GPRMC... ", "GPRMC" )!=1){
+    if (trame_cmp("$GPRMC ...","GPRMC")!=1){
         printf ("Erreur Test unitaire trame_cmp.\n");
         exit(-1);
     }
-    if (trame_cmp("$APRMC...", "GPGGA")!=0){
+    if (trame_cmp("$APRMC ...","GPGGA")!=0){
         printf ("Erreur Test unitaire trame_cmp.\n");
         exit(-1);
     }
-}
-
-// Ne pas modifier cette fonction
+}
+
+// Ne pas modifier cette fonction
 int main(int argc,char ** argv)
-int trame_cmp(char *trame, char *type)
-{
-
-    tests_unitaires();
-
+{
+
+    tests_unitaires();
+
     // Affichage des trames definies dans la table trames.
+    printf ("Trames de tests tableau trames:\n");
+    int i=0;
+    while (trames[i])
+        traitement(trames[i++]);
 
-
-    printf ("Trames de tests tableau trames:\n");
-    int i=0;
-    while (trames[i])
-        traitement(trames[i++]);
-
-    if (!trame_init())
-        exit(-1);
-    // Affichage des trames du fichier gps.log
-    char *trame;
-    printf ("Trames de tests du fichier gps.log\n");
-    while  ((trame = trame_suivante()))
+    if (!trame_init())
+        exit(-1);
+    // Affichage des trames du fichier gps.log
+    char *trame;
+    printf ("Trames de tests du fichier gps.log\n");
+    while  ((trame = trame_suivante()))
         traitement(trame);
 
-    int res;
-    char type[]="$GPGGA";
-    res=trame_cmp(trame, type);
-    printf("%d", res)
-
-    return 0;
-}
+    return 0;
+}